diff --git a/drivers/gpu/drm/rockchip/ebc-dev/ebc_dev_v8.S b/drivers/gpu/drm/rockchip/ebc-dev/ebc_dev_v8.S
index bdc4e186657a..66959f00f029 100644
--- a/drivers/gpu/drm/rockchip/ebc-dev/ebc_dev_v8.S
+++ b/drivers/gpu/drm/rockchip/ebc-dev/ebc_dev_v8.S
@@ -8661,320 +8706,188 @@ ebc_thread:
 	.cfi_restore 20
 	.cfi_def_cfa 31, 0
 	ret
-.LVL758:
+.LVL775:
 	.p2align 3
-.L761:
+.L769:
 	.cfi_restore_state
-	.loc 1 1603 0
+	.loc 1 1609 0
 	ldr	w0, [x24, 28]
-.LVL759:
+.LVL776:
 	cmp	w0, 1
-	beq	.L891
-	.loc 1 1612 0
+	beq	.L905
+	.loc 1 1618 0
 	ldr	w0, [x24, 184]
 	cmp	w0, 1
-	beq	.L892
-.LVL760:
-.L882:
+	beq	.L906
+.LVL777:
+.L891:
 	ldr	w0, [x24, 80]
-.LVL761:
-	.loc 1 1615 0
-	cbz	w0, .L893
-.L845:
-.LVL762:
-.L835:
-	.loc 1 1617 0
+.LVL778:
+	.loc 1 1621 0
+	cbz	w0, .L907
+.L854:
+.LVL779:
+.L844:
+	.loc 1 1623 0
 	str	wzr, [x24, 80]
-	b	.L758
-.LVL763:
+	b	.L766
+.LVL780:
 	.p2align 3
-.L893:
-.LBB1806:
-.LBB1804:
-	.loc 1 1616 0 discriminator 1
+.L907:
+.LBB1799:
+.LBB1797:
+	.loc 1 1622 0 discriminator 1
 	mov	w1, 0
 	add	x0, x29, 112
 	bl	init_wait_entry
-.LVL764:
-	b	.L846
+.LVL781:
+	b	.L855
 	.p2align 3
-.L894:
-.LVL765:
-.LBB1802:
-	.loc 1 1616 0 is_stmt 0 discriminator 5
-	cbnz	x0, .L835
-	.loc 1 1616 0 discriminator 7
+.L908:
+.LVL782:
+.LBB1795:
+	.loc 1 1622 0 is_stmt 0 discriminator 5
+	cbnz	x0, .L844
+	.loc 1 1622 0 discriminator 7
 	bl	schedule
-.LVL766:
-.L846:
-	.loc 1 1616 0 discriminator 9
+.LVL783:
+.L855:
+	.loc 1 1622 0 discriminator 9
 	add	x1, x29, 112
 	mov	w2, 1
 	mov	x0, x19
 	bl	prepare_to_wait_event
-.LVL767:
+.LVL784:
 	ldr	w1, [x24, 80]
-	cbz	w1, .L894
-.LBE1802:
-	.loc 1 1616 0 discriminator 4
+	cbz	w1, .L908
+.LBE1795:
+	.loc 1 1622 0 discriminator 4
 	add	x1, x29, 112
 	mov	x0, x19
 	bl	finish_wait
-.LVL768:
-.LBE1804:
-.LBE1806:
-	.loc 1 1617 0 is_stmt 1 discriminator 4
+.LVL785:
+.LBE1797:
+.LBE1799:
+	.loc 1 1623 0 is_stmt 1 discriminator 4
 	str	wzr, [x24, 80]
-	b	.L758
-.LVL769:
+	b	.L766
+.LVL786:
 	.p2align 3
-.L764:
-	.loc 1 1360 0
+.L778:
+	.loc 1 1390 0
+	mov	x0, x28
+	str	x28, [x24, 200]
+	b	.L779
+.LVL787:
+	.p2align 3
+.L772:
+	.loc 1 1363 0
 	cmp	w1, 18
 	ccmp	w1, 21, 4, ne
-	bne	.L767
-	.loc 1 1361 0
+	bne	.L776
+	.loc 1 1364 0
 	str	wzr, [x24, 608]
-.L763:
-	.loc 1 1384 0
-	adrp	x25, jiffies
-.LVL770:
-	mov	x1, 402653184
-	add	x0, x20, 616
-	ldr	x2, [x25, #:lo12:jiffies]
-	add	x1, x2, x1
-	bl	mod_timer
-.LVL771:
-	.loc 1 1386 0
-	ldr	w0, [x24, 428]
-	cbz	w0, .L769
-	ldr	x0, [x24, 200]
-.L770:
-	.loc 1 1389 0
-	ldr	w2, [x0, 40]
-	ldr	w3, [x28, 40]
-	cmp	w3, w2
-	beq	.L771
-	.loc 1 1390 0
-	ldr	x0, [x24, 88]
-	adrp	x1, .LC79
-	add	x1, x1, :lo12:.LC79
-	bl	_dev_info
-.LVL772:
-	.loc 1 1391 0
-	ldr	w0, [x24, 28]
-	cmp	w0, 1
-	beq	.L895
-.L880:
-	ldr	w2, [x28, 40]
-.L771:
-	.loc 1 1398 0
-	cmp	w2, 11
-	bgt	.L778
-	cmp	w2, 7
-	bge	.L779
-	cmp	w2, 1
-	beq	.L780
-	bgt	.L850
-	cbnz	w2, .L777
-	.loc 1 1443 0
-	add	x0, x21, 624
-	bl	down_write
-.LVL773:
-	.loc 1 1449 0
-	ldr	x0, [x24, 200]
-	.loc 1 1444 0
-	str	x28, [x24, 208]
-	.loc 1 1449 0
-	ldr	w0, [x0, 40]
-	cmp	w0, 1
-	bls	.L814
-	.loc 1 1451 0
-	ldrsw	x2, [x24, 20]
-	ldr	x1, [x28, 16]
-	ldr	x0, [x24, 128]
-	bl	memcpy
-.LVL774:
-	.loc 1 1452 0
-	ldr	x0, [x24, 200]
-	ldrsw	x2, [x24, 20]
-	ldr	x1, [x0, 16]
-	ldr	x0, [x24, 136]
-	bl	memcpy
-.LVL775:
-.L815:
-	.loc 1 1458 0
-	add	x0, x21, 624
-	bl	up_write
-.LVL776:
-	.loc 1 1460 0
-	ldr	w0, [x24, 28]
-	cbnz	w0, .L792
-	.loc 1 1461 0
-	mov	w0, 1
-	str	w0, [x24, 28]
-	.loc 1 1463 0
-	ldr	w0, [x24, 184]
-	.loc 1 1462 0
-	str	wzr, [x24, 76]
-	.loc 1 1463 0
-	cbz	w0, .L896
-.L816:
-	.loc 1 1465 0
-	mov	x0, x20
-	bl	ebc_lut_update
-.LVL777:
-	cmn	w0, #1
-	beq	.L897
-	.loc 1 1473 0
-	ldr	x0, [x24, 88]
-	adrp	x1, .LC85
-	.loc 1 1470 0
-	ldr	w3, [x24, 96]
-	.loc 1 1473 0
-	add	x1, x1, :lo12:.LC85
-	.loc 1 1470 0
-	strb	w3, [x24, 32]
-.LVL778:
-.L881:
-	.loc 1 1473 0
-	and	w2, w3, 255
-	.loc 1 1471 0
-	lsr	w3, w3, 8
-	strb	w3, [x24, 33]
-	.loc 1 1473 0
-	bl	_dev_info
-.LVL779:
-	.loc 1 1474 0
-	mov	x0, x20
-	bl	ebc_frame_start
-.LVL780:
-	.loc 1 1577 0
-	ldr	x0, [x24, 208]
-	ldr	w0, [x0, 40]
-	cmp	w0, 20
-	bne	.L831
-.LVL781:
-.L902:
-	.loc 1 1580 0
+	b	.L771
+.LVL788:
+.L792:
+	.loc 1 1401 0
+	cmp	w2, 21
+	ble	.L859
+.L786:
+	.loc 1 1572 0
 	ldr	x0, [x24, 88]
-	.loc 1 1578 0
-	mov	w25, 1
-.LVL782:
-	.loc 1 1579 0
-	str	wzr, [x24, 188]
-	.loc 1 1580 0
-	adrp	x1, .LC88
-	.loc 1 1578 0
-	str	w25, [x24, 600]
-	.loc 1 1580 0
-	add	x1, x1, :lo12:.LC88
-	bl	_dev_info
-.LVL783:
-	.loc 1 1581 0
-	mov	w2, w25
-	mov	w1, w25
-	add	x0, x21, 328
-	bl	__wake_up_sync
-.LVL784:
-	.loc 1 1592 0
+	adrp	x1, .LC90
+	add	x1, x1, :lo12:.LC90
+	bl	_dev_err
+.LVL789:
+	.loc 1 1573 0
 	mov	x0, x28
+.LVL790:
+.L888:
 	bl	ebc_remove_from_dsp_buf_list
-.LVL785:
-	.loc 1 1594 0
-	ldr	w0, [x24, 428]
-	cbz	w0, .L833
-.LVL786:
-	.p2align 2
-.L904:
-	.loc 1 1595 0
-	ldr	x0, [x24, 200]
-	bl	ebc_buf_release
-.LVL787:
-	b	.L834
-.LVL788:
-	.p2align 3
-.L769:
-	.loc 1 1387 0
+.LVL791:
+	.loc 1 1574 0
 	mov	x0, x28
-	str	x28, [x24, 200]
-	b	.L770
-.LVL789:
+	bl	ebc_buf_release
+.LVL792:
+	.loc 1 1576 0
+	b	.L766
+.LVL793:
 	.p2align 3
-.L887:
+.L896:
 	.loc 1 1345 0
 	str	wzr, [x24, 604]
 	.loc 1 1344 0
 	str	wzr, [x24, 608]
-	b	.L763
-.LVL790:
+	b	.L771
+.LVL794:
 	.p2align 3
-.L778:
-	.loc 1 1398 0
+.L787:
+	.loc 1 1401 0
 	cmp	w2, 15
-	bgt	.L783
+	bgt	.L792
 	cmp	w2, 14
-	bge	.L779
-.L850:
-	.loc 1 1499 0
+	bge	.L788
+.L859:
+	.loc 1 1502 0
 	ldr	x26, [x24, 200]
-	.loc 1 1490 0
+	.loc 1 1493 0
 	mov	w7, 1
-.LVL791:
-	.loc 1 1500 0
+.LVL795:
+	.loc 1 1503 0
 	ldr	w0, [x26, 40]
 	cmp	w0, 1
-	bls	.L898
-.L818:
-	.loc 1 1511 0
+	bls	.L909
+.L827:
+	.loc 1 1514 0
 	str	wzr, [x24, 76]
-	.loc 1 1512 0
-	str	x28, [x24, 208]
 	.loc 1 1515 0
+	str	x28, [x24, 208]
+	.loc 1 1518 0
 	ldr	w0, [x28, 40]
 	sub	w0, w0, #2
-	.loc 1 1514 0
-	cmp	w0, 14
-	bhi	.L819
-.L899:
 	.loc 1 1517 0
+	cmp	w0, 14
+	bhi	.L828
+.L910:
+	.loc 1 1520 0
 	ldr	x0, [x24, 200]
-.LBB1807:
-.LBB1808:
+.LBB1800:
+.LBB1801:
 	.loc 1 1309 0
 	ldr	w1, [x24, 20]
-.LBE1808:
-.LBE1807:
-	.loc 1 1516 0
+.LBE1801:
+.LBE1800:
+	.loc 1 1519 0
 	ldr	x4, [x28, 16]
-.LBB1811:
-.LBB1809:
+.LBB1804:
+.LBB1802:
 	.loc 1 1309 0
 	cmp	w1, 0
-.LBE1809:
-.LBE1811:
-	.loc 1 1517 0
+.LBE1802:
+.LBE1804:
+	.loc 1 1520 0
 	ldr	x5, [x0, 16]
-.LBB1812:
-.LBB1810:
+.LBB1805:
+.LBB1803:
 	.loc 1 1309 0
 	add	w0, w1, 7
 	csel	w0, w0, w1, lt
 	asr	w0, w0, 3
 	cmp	w0, 0
-	ble	.L820
+	ble	.L829
 	.loc 1 1313 0
 	ldr	x1, [x4]
 	ldr	x2, [x5]
 	cmp	x2, x1
-	bne	.L819
+	bne	.L828
 	sub	w1, w0, #1
 	mov	x0, 8
 	add	x1, x1, 1
 	lsl	x1, x1, 3
-	b	.L822
+	b	.L831
 	.p2align 3
-.L823:
+.L832:
 	.loc 1 1310 0
 	ldr	x3, [x4, x0]
 	add	x0, x0, 8
@@ -8983,205 +8896,226 @@ ebc_thread:
 	.loc 1 1313 0
 	ldr	x2, [x2, -8]
 	cmp	x3, x2
-	bne	.L819
-.L822:
+	bne	.L828
+.L831:
 	.loc 1 1309 0
 	cmp	x1, x0
-	bne	.L823
-.L820:
-.LBE1810:
-.LBE1812:
-	.loc 1 1519 0
+	bne	.L832
+.L829:
+.LBE1803:
+.LBE1805:
+	.loc 1 1522 0
 	ldr	x0, [x24, 88]
-	adrp	x1, .LC90
-	add	x1, x1, :lo12:.LC90
+	adrp	x1, .LC93
+	add	x1, x1, :lo12:.LC93
 	bl	_dev_info
-.LVL792:
-	.loc 1 1521 0
+.LVL796:
+	.loc 1 1524 0
 	str	x26, [x24, 200]
-	.loc 1 1523 0
-	b	.L792
+	.loc 1 1583 0
+	ldr	x0, [x24, 208]
+	ldr	w0, [x0, 40]
+	cmp	w0, 20
+	bne	.L840
+.LVL797:
+.L900:
+	.loc 1 1586 0
+	ldr	x0, [x24, 88]
+	.loc 1 1584 0
+	mov	w25, 1
+.LVL798:
+	.loc 1 1585 0
+	str	wzr, [x24, 188]
+	.loc 1 1586 0
+	adrp	x1, .LC91
+	.loc 1 1584 0
+	str	w25, [x24, 600]
+	.loc 1 1586 0
+	add	x1, x1, :lo12:.LC91
+	bl	_dev_info
+.LVL799:
+	.loc 1 1587 0
+	mov	w2, w25
+	mov	w1, w25
+	add	x0, x21, 328
+	bl	__wake_up_sync
+.LVL800:
+	.loc 1 1598 0
+	mov	x0, x28
+	bl	ebc_remove_from_dsp_buf_list
+.LVL801:
+	.loc 1 1600 0
+	ldr	w0, [x24, 428]
+	cbz	w0, .L842
+.LVL802:
+	.p2align 2
+.L902:
+	.loc 1 1601 0
+	ldr	x0, [x24, 200]
+	bl	ebc_buf_release
+.LVL803:
+	b	.L843
+.LVL804:
 	.p2align 3
-.L779:
-	.loc 1 1499 0
+.L788:
+	.loc 1 1502 0
 	ldr	x26, [x24, 200]
-	.loc 1 1398 0
+	.loc 1 1401 0
 	mov	w7, 0
-.LVL793:
-	.loc 1 1500 0
+.LVL805:
+	.loc 1 1503 0
 	ldr	w0, [x26, 40]
 	cmp	w0, 1
-	bhi	.L818
-.L898:
-	.loc 1 1505 0
+	bhi	.L827
+.L909:
+	.loc 1 1508 0
 	add	x0, x29, 152
-	.loc 1 1511 0
+	.loc 1 1514 0
 	str	wzr, [x24, 76]
-	.loc 1 1505 0
+	.loc 1 1508 0
 	str	x0, [x24, 200]
-	.loc 1 1512 0
+	.loc 1 1515 0
 	str	x28, [x24, 208]
-	.loc 1 1506 0
+	.loc 1 1509 0
 	ldr	x0, [x24, 136]
 	str	x0, [x29, 168]
-	.loc 1 1515 0
+	.loc 1 1518 0
 	ldr	w0, [x28, 40]
 	sub	w0, w0, #2
-	.loc 1 1514 0
+	.loc 1 1517 0
 	cmp	w0, 14
-	bls	.L899
+	bls	.L910
 	.p2align 2
-.L819:
-	.loc 1 1527 0
-	cbnz	w7, .L854
-	.loc 1 1531 0
+.L828:
+	.loc 1 1530 0
+	cbnz	w7, .L863
+	.loc 1 1534 0
 	ldr	w0, [x24, 48]
 	cmp	w0, 0
-	ble	.L824
-	.loc 1 1532 0
+	ble	.L833
+	.loc 1 1535 0
 	add	w23, w23, 1
-	.loc 1 1533 0
+	.loc 1 1536 0
 	cmp	w0, w23
-	ble	.L900
-.L824:
-	.loc 1 1539 0
-	ldr	w0, [x24, 184]
-	cbz	w0, .L901
-.L825:
+	bgt	.L833
+	.loc 1 1537 0
+	mov	w0, 2
+	.loc 1 1538 0
+	mov	w23, 0
+	.loc 1 1537 0
+	str	w0, [x28, 40]
+.L833:
 	.loc 1 1542 0
+	ldr	w0, [x24, 184]
+	cbz	w0, .L911
+.L834:
+	.loc 1 1545 0
 	mov	x0, x20
 	bl	ebc_lut_update
-.LVL794:
-	cbz	w0, .L826
-	.loc 1 1543 0
+.LVL806:
+	cbz	w0, .L835
+	.loc 1 1546 0
 	ldr	x0, [x24, 88]
-	adrp	x1, .LC84
-	add	x1, x1, :lo12:.LC84
+	adrp	x1, .LC87
+	add	x1, x1, :lo12:.LC87
 	bl	_dev_err
-.LVL795:
-	.loc 1 1545 0
+.LVL807:
+	.loc 1 1548 0
 	str	x26, [x24, 200]
-.LVL796:
-	.p2align 2
-.L792:
-	.loc 1 1577 0
-	ldr	x0, [x24, 208]
-	ldr	w0, [x0, 40]
-	cmp	w0, 20
-	beq	.L902
-.L831:
-	.loc 1 1583 0
-	cmp	w0, 18
-	beq	.L903
-.L832:
-	.loc 1 1592 0
-	mov	x0, x28
-	bl	ebc_remove_from_dsp_buf_list
-.LVL797:
-	.loc 1 1594 0
-	ldr	w0, [x24, 428]
-	cbnz	w0, .L904
-.L833:
-	.loc 1 1597 0
-	mov	w0, 1
-	str	w0, [x24, 428]
-.L834:
-	.loc 1 1599 0
-	ldr	x0, [x24, 208]
-	str	x0, [x24, 200]
-	.loc 1 1600 0
-	b	.L758
+	.loc 1 1549 0
+	b	.L801
+.LVL808:
 	.p2align 3
-.L891:
-.LBB1813:
-	.loc 1 1604 0 discriminator 1
+.L905:
+.LBB1806:
+	.loc 1 1610 0 discriminator 1
 	ldr	w0, [x24, 80]
-	cbnz	w0, .L835
-.LBB1814:
-	.loc 1 1604 0 is_stmt 0 discriminator 3
+	cbnz	w0, .L844
+.LBB1807:
+	.loc 1 1610 0 is_stmt 0 discriminator 3
 	mov	w1, 0
 	add	x0, x29, 112
 	bl	init_wait_entry
-.LVL798:
-	b	.L839
+.LVL809:
+	b	.L848
 	.p2align 3
-.L905:
-.LBB1815:
-	.loc 1 1604 0 discriminator 7
+.L912:
+.LBB1808:
+	.loc 1 1610 0 discriminator 7
 	ldr	w1, [x24, 80]
-	cbnz	w1, .L836
-.LVL799:
-	.loc 1 1604 0 discriminator 9
-	cbnz	x0, .L882
-	.loc 1 1604 0 discriminator 11
+	cbnz	w1, .L845
+.LVL810:
+	.loc 1 1610 0 discriminator 9
+	cbnz	x0, .L891
+	.loc 1 1610 0 discriminator 11
 	bl	schedule
-.LVL800:
-.L839:
-	.loc 1 1604 0 discriminator 13
+.LVL811:
+.L848:
+	.loc 1 1610 0 discriminator 13
 	add	x1, x29, 112
 	mov	w2, 1
 	mov	x0, x19
 	bl	prepare_to_wait_event
-.LVL801:
+.LVL812:
 	ldr	w1, [x24, 28]
-	cbnz	w1, .L905
-.L836:
-.LBE1815:
-	.loc 1 1604 0 discriminator 8
+	cbnz	w1, .L912
+.L845:
+.LBE1808:
+	.loc 1 1610 0 discriminator 8
 	mov	x0, x19
 	add	x1, x29, 112
 	bl	finish_wait
-.LVL802:
+.LVL813:
 	ldr	w0, [x24, 28]
-.LBE1814:
-.LBE1813:
-	.loc 1 1607 0 is_stmt 1 discriminator 8
-	cbnz	w0, .L882
-	.loc 1 1612 0
+.LBE1807:
+.LBE1806:
+	.loc 1 1613 0 is_stmt 1 discriminator 8
+	cbnz	w0, .L891
+	.loc 1 1618 0
 	ldr	w0, [x24, 184]
 	cmp	w0, 1
-	bne	.L882
+	bne	.L891
 	.p2align 2
-.L892:
-.LBB1816:
-.LBB1817:
+.L906:
+.LBB1809:
+.LBB1810:
 	mov	w1, 0
 	mov	x0, x20
 	bl	ebc_power_set.part.8
-.LVL803:
-	b	.L882
-.LVL804:
+.LVL814:
+	b	.L891
+.LVL815:
 	.p2align 3
-.L767:
-.LBE1817:
-.LBE1816:
-	.loc 1 1363 0
+.L776:
+.LBE1810:
+.LBE1809:
+	.loc 1 1366 0
 	ldr	w0, [x24, 608]
-.LVL805:
+.LVL816:
 	cmp	w0, 0
 	ccmp	w1, 1, 4, ne
-	beq	.L763
-	.loc 1 1364 0
+	beq	.L771
+	.loc 1 1367 0
 	add	x25, x21, 624
-.LVL806:
+.LVL817:
 	mov	x0, x25
 	bl	down_write
-.LVL807:
-	.loc 1 1365 0
+.LVL818:
+	.loc 1 1368 0
 	ldrsw	x2, [x24, 20]
 	ldr	x1, [x28, 16]
 	ldr	x0, [x24, 144]
 	bl	memcpy
-.LVL808:
-	.loc 1 1366 0
+.LVL819:
+	.loc 1 1369 0
 	mov	x0, x28
 	bl	ebc_remove_from_dsp_buf_list
-.LVL809:
-	.loc 1 1367 0
+.LVL820:
+	.loc 1 1370 0
 	mov	x0, x28
 	bl	ebc_buf_release
-.LVL810:
-	.loc 1 1369 0
+.LVL821:
+	.loc 1 1372 0
 	ldr	x1, [x24, 208]
 	mov	x4, x24
 	ldr	x0, [x24, 128]
@@ -9189,71 +9123,58 @@ ebc_thread:
 	ldr	w5, [x1, 40]
 	ldr	x1, [x1, 16]
 	bl	refresh_new_image2
-.LVL811:
-	.loc 1 1372 0
+.LVL822:
+	.loc 1 1375 0
 	mov	x0, x25
 	bl	up_write
-.LVL812:
-	.loc 1 1373 0
-	ldr	w0, [x24, 28]
-	cbnz	w0, .L758
+.LVL823:
 	.loc 1 1376 0
+	ldr	w0, [x24, 28]
+	cbnz	w0, .L766
+	.loc 1 1379 0
 	ldr	w0, [x24, 184]
-	.loc 1 1374 0
+	.loc 1 1377 0
 	mov	w1, 1
-	.loc 1 1375 0
+	.loc 1 1378 0
 	str	wzr, [x24, 76]
-	.loc 1 1374 0
+	.loc 1 1377 0
 	str	w1, [x24, 28]
-	.loc 1 1376 0
-	cbz	w0, .L906
-.L768:
-	.loc 1 1378 0
+	.loc 1 1379 0
+	cbz	w0, .L913
+.L777:
+	.loc 1 1381 0
 	ldr	x0, [x24, 88]
-	adrp	x1, .LC78
+	adrp	x1, .LC81
 	ldrb	w2, [x24, 32]
-	add	x1, x1, :lo12:.LC78
+	add	x1, x1, :lo12:.LC81
 	bl	_dev_info
-.LVL813:
-	.loc 1 1379 0
+.LVL824:
+	.loc 1 1382 0
 	mov	x0, x20
 	bl	ebc_frame_start
-.LVL814:
-	b	.L758
-.L783:
-	.loc 1 1398 0
-	cmp	w2, 21
-	ble	.L850
-.L777:
-	.loc 1 1569 0
-	ldr	x0, [x24, 88]
-	adrp	x1, .LC87
-	add	x1, x1, :lo12:.LC87
-	bl	_dev_err
-.LVL815:
-	.loc 1 1570 0
-	b	.L792
+.LVL825:
+	b	.L766
 	.p2align 3
-.L780:
-	.loc 1 1400 0
+.L789:
+	.loc 1 1403 0
 	ldr	w0, [x24, 604]
-	cbz	w0, .L784
-	.loc 1 1413 0
+	cbz	w0, .L793
+	.loc 1 1416 0
 	ldr	x0, [x24, 200]
-	.loc 1 1411 0
+	.loc 1 1414 0
 	str	x28, [x24, 208]
-	.loc 1 1401 0
+	.loc 1 1404 0
 	str	w2, [x24, 608]
-	.loc 1 1413 0
+	.loc 1 1416 0
 	ldr	w1, [x0, 40]
 	cmp	w1, 1
-	bhi	.L785
+	bhi	.L794
 	mov	x0, x28
-	.loc 1 1418 0
-	cbz	w1, .L907
-.L787:
-.LBB1818:
-.LBB1819:
+	.loc 1 1421 0
+	cbz	w1, .L914
+.L796:
+.LBB1811:
+.LBB1812:
 	.loc 1 374 0
 	ldp	w3, w14, [x0, 48]
 	.loc 1 433 0
@@ -9281,23 +9202,23 @@ ebc_thread:
 	asr	w8, w8, 3
 	.loc 1 377 0
 	asr	w16, w16, 3
-.LVL816:
+.LVL826:
 	.loc 1 373 0
 	add	w8, w8, 1
-.LVL817:
+.LVL827:
 	ldr	w1, [x20, 236]
 	.loc 1 380 0
 	cmp	w8, w16
-.LBE1819:
-.LBE1818:
-	.loc 1 1422 0
+.LBE1812:
+.LBE1811:
+	.loc 1 1425 0
 	ldr	x11, [x0, 16]
-.LBB1824:
-.LBB1820:
+.LBB1817:
+.LBB1813:
 	.loc 1 380 0
 	sub	w0, w16, #1
 	csel	w8, w0, w8, ge
-.LVL818:
+.LVL828:
 	.loc 1 382 0
 	cmp	w1, w17
 	sub	w1, w1, #1
@@ -9307,106 +9228,106 @@ ebc_thread:
 	csel	w17, w1, w17, le
 	.loc 1 372 0
 	asr	w15, w15, 3
-.LVL819:
+.LVL829:
 	mul	w5, w14, w16
 	.loc 1 384 0
 	cmp	w14, w17
-.LBE1820:
-.LBE1824:
-	.loc 1 1422 0
+.LBE1813:
+.LBE1817:
+	.loc 1 1425 0
 	ldr	x7, [x24, 128]
-	.loc 1 1423 0
+	.loc 1 1426 0
 	ldp	x10, x9, [x24, 144]
-.LBB1825:
-.LBB1821:
+.LBB1818:
+.LBB1814:
 	.loc 1 384 0
-	bgt	.L795
-.LVL820:
+	bgt	.L804
+.LVL830:
 	.p2align 2
-.L865:
+.L874:
 	.loc 1 389 0
 	mov	w4, w15
 	cmp	w15, w8
-	ble	.L866
-	b	.L812
-.LVL821:
+	ble	.L875
+	b	.L821
+.LVL831:
 	.p2align 3
-.L796:
+.L805:
 	.loc 1 402 0
 	tst	x2, 65280
-	bne	.L797
+	bne	.L806
 	.loc 1 403 0
 	and	w26, w1, 240
 	cmp	w26, 224
-	beq	.L908
+	beq	.L915
 	.loc 1 406 0
 	orr	w18, w18, 240
-.L797:
+.L806:
 	.loc 1 408 0
 	tst	x2, 16711680
-	bne	.L799
+	bne	.L808
 	.loc 1 409 0
 	and	w26, w1, 3840
 	cmp	w26, 3584
-	beq	.L909
+	beq	.L916
 	.loc 1 412 0
 	orr	w18, w18, 3840
-.L799:
+.L808:
 	.loc 1 414 0
 	tst	x2, 4278190080
-	bne	.L801
+	bne	.L810
 	.loc 1 415 0
 	and	w26, w1, 61440
 	cmp	w26, 57344
-	beq	.L910
+	beq	.L917
 	.loc 1 418 0
 	orr	w18, w18, 61440
-.L801:
+.L810:
 	.loc 1 420 0
 	tst	x2, 1095216660480
-	bne	.L803
+	bne	.L812
 	.loc 1 421 0
 	and	w26, w1, 983040
 	cmp	w26, 917504
-	beq	.L911
+	beq	.L918
 	.loc 1 424 0
 	orr	w18, w18, 983040
-.L803:
+.L812:
 	.loc 1 426 0
 	tst	x2, 280375465082880
-	bne	.L805
+	bne	.L814
 	.loc 1 427 0
 	and	w26, w1, 15728640
 	cmp	w26, 14680064
-	beq	.L912
+	beq	.L919
 	.loc 1 430 0
 	orr	w18, w18, 15728640
-.L805:
+.L814:
 	.loc 1 432 0
 	tst	x2, 71776119061217280
-	bne	.L807
+	bne	.L816
 	.loc 1 433 0
 	and	w26, w1, 251658240
 	cmp	w26, w13
-	beq	.L913
+	beq	.L920
 	.loc 1 436 0
 	orr	w18, w18, 251658240
-.L807:
+.L816:
 	.loc 1 438 0
 	tst	x2, -72057594037927936
-	bne	.L809
+	bne	.L818
 	.loc 1 439 0
 	and	w2, w1, -268435456
-.LVL822:
+.LVL832:
 	cmp	w2, w12
-	beq	.L914
+	beq	.L921
 	.loc 1 442 0
 	orr	w18, w18, -268435456
-.LVL823:
-.L809:
+.LVL833:
+.L818:
 	.loc 1 445 0
 	and	w1, w1, w25
-.LVL824:
+.LVL834:
 	.loc 1 389 0
 	add	w4, w4, 1
 	eor	w1, w1, w3
@@ -9417,19 +9338,19 @@ ebc_thread:
 	.loc 1 446 0
 	str	w1, [x7, x0]
 	.loc 1 389 0
-	bgt	.L812
-.LVL825:
-.L866:
+	bgt	.L821
+.LVL835:
+.L875:
 	.loc 1 390 0
 	sxtw	x0, w4
-.LVL826:
+.LVL836:
 	.loc 1 394 0
 	mov	w18, 0
 	.loc 1 393 0
 	lsl	x1, x0, 3
 	.loc 1 390 0
 	lsl	x0, x0, 2
-.LVL827:
+.LVL837:
 	.loc 1 393 0
 	add	x1, x1, x5, sxtw 3
 	add	x0, x0, x5, sxtw 2
@@ -9440,150 +9361,214 @@ ebc_thread:
 	ldr	w1, [x11, x0]
 	.loc 1 396 0
 	and	x26, x2, 255
-.LVL828:
+.LVL838:
 	.loc 1 392 0
 	ldr	w25, [x10, x0]
-.LVL829:
+.LVL839:
 	.loc 1 396 0
-	cbnz	x26, .L796
-.LVL830:
+	cbnz	x26, .L805
+.LVL840:
 	.loc 1 397 0
 	and	w26, w1, 15
 	.loc 1 400 0
 	mov	w18, 15
 	.loc 1 397 0
 	cmp	w26, 14
-	bne	.L796
+	bne	.L805
 	.loc 1 398 0
 	orr	w3, w3, w18
-.LVL831:
+.LVL841:
 	.loc 1 394 0
 	mov	w18, 0
-.LVL832:
-	b	.L796
-.LVL833:
+.LVL842:
+	b	.L805
+.LVL843:
 	.p2align 3
-.L826:
-.LBE1821:
-.LBE1825:
-	.loc 1 1554 0
+.L835:
+.LBE1814:
+.LBE1818:
+	.loc 1 1557 0
 	ldr	x0, [x24, 208]
-	adrp	x1, .LC86
-	.loc 1 1551 0
+	adrp	x1, .LC89
+	.loc 1 1554 0
 	ldr	w3, [x24, 96]
+	.loc 1 1557 0
+	add	x1, x1, :lo12:.LC89
 	.loc 1 1554 0
-	add	x1, x1, :lo12:.LC86
-	.loc 1 1551 0
 	strb	w3, [x24, 32]
-	.loc 1 1554 0
+	.loc 1 1557 0
 	and	w3, w3, 255
 	ldr	w2, [x0, 40]
 	ldr	x0, [x24, 88]
 	bl	_dev_info
-.LVL834:
-	.loc 1 1555 0
+.LVL844:
+	.loc 1 1558 0
 	mov	w0, 1
 	str	w0, [x24, 28]
-	.loc 1 1556 0
+	.loc 1 1559 0
 	mov	x0, x20
 	bl	ebc_frame_start
-.LVL835:
-	.loc 1 1558 0
+.LVL845:
+	.loc 1 1561 0
 	ldr	x1, [x25, #:lo12:jiffies]
 	add	x0, x20, 672
 	str	x0, [x29, 104]
 	add	x1, x1, 900
 	bl	mod_timer
-.LVL836:
-.LBB1826:
-	.loc 1 1559 0
+.LVL846:
+.LBB1819:
+	.loc 1 1562 0
 	ldr	w0, [x24, 76]
-	cbz	w0, .L915
-.L829:
-.LVL837:
-.L827:
-.LBE1826:
-	.loc 1 1561 0 discriminator 11
+	cbz	w0, .L922
+.L838:
+.LVL847:
+.L836:
+.LBE1819:
+	.loc 1 1564 0 discriminator 11
 	ldr	x2, [x25, #:lo12:jiffies]
 	mov	x1, 402653184
 	ldr	x0, [x29, 104]
-.LVL838:
+.LVL848:
 	add	x1, x2, x1
 	bl	mod_timer
-.LVL839:
-	.loc 1 1562 0 discriminator 11
+.LVL849:
+	.loc 1 1565 0 discriminator 11
 	str	wzr, [x24, 76]
-	.loc 1 1564 0 discriminator 11
+	.loc 1 1567 0 discriminator 11
 	str	x26, [x24, 200]
-	.loc 1 1566 0 discriminator 11
-	b	.L792
-.LVL840:
+	.loc 1 1569 0 discriminator 11
+	b	.L801
+.LVL850:
 	.p2align 3
-.L854:
-	.loc 1 1539 0
+.L863:
+	.loc 1 1542 0
 	ldr	w0, [x24, 184]
-	.loc 1 1528 0
+	.loc 1 1531 0
 	mov	w23, 0
-	.loc 1 1539 0
-	cbnz	w0, .L825
-.L901:
-	.loc 1 1540 0
+	.loc 1 1542 0
+	cbnz	w0, .L834
+.L911:
+	.loc 1 1543 0
 	mov	x0, x20
 	bl	ebc_power_set.constprop.12
-.LVL841:
-	b	.L825
-.L895:
-	.loc 1 1392 0
+.LVL851:
+	b	.L834
+.L899:
+	.loc 1 1464 0
+	mov	w0, 1
+	str	w0, [x24, 28]
+	.loc 1 1466 0
+	ldr	w0, [x24, 184]
+	.loc 1 1465 0
+	str	wzr, [x24, 76]
+	.loc 1 1466 0
+	cbz	w0, .L923
+	.loc 1 1468 0
+	mov	x0, x20
+	bl	ebc_lut_update
+.LVL852:
+	cmn	w0, #1
+	beq	.L924
+.L826:
+	.loc 1 1476 0
 	ldr	x0, [x24, 88]
-	adrp	x1, .LC80
-	add	x1, x1, :lo12:.LC80
+	adrp	x1, .LC88
+	.loc 1 1473 0
+	ldr	w3, [x24, 96]
+	.loc 1 1476 0
+	add	x1, x1, :lo12:.LC88
+	.loc 1 1473 0
+	strb	w3, [x24, 32]
+.LVL853:
+.L890:
+	.loc 1 1476 0
+	and	w2, w3, 255
+	.loc 1 1474 0
+	lsr	w3, w3, 8
+	strb	w3, [x24, 33]
+	.loc 1 1476 0
 	bl	_dev_info
-.LVL842:
-.LBB1830:
-	.loc 1 1393 0
+.LVL854:
+	.loc 1 1477 0
+	mov	x0, x20
+	bl	ebc_frame_start
+.LVL855:
+	b	.L801
+.LVL856:
+.L898:
+	.loc 1 1395 0
+	ldr	x0, [x24, 88]
+	adrp	x1, .LC83
+	add	x1, x1, :lo12:.LC83
+	bl	_dev_info
+.LVL857:
+.LBB1823:
+	.loc 1 1396 0
 	ldr	w0, [x24, 76]
-	cbz	w0, .L916
-.L775:
-.LVL843:
-.L773:
-.LBE1830:
-	.loc 1 1394 0 discriminator 11
+	cbz	w0, .L925
+.L784:
+.LVL858:
+.L782:
+.LBE1823:
+	.loc 1 1397 0 discriminator 11
 	ldr	x0, [x24, 88]
-.LVL844:
-	adrp	x1, .LC81
-	add	x1, x1, :lo12:.LC81
+.LVL859:
+	adrp	x1, .LC84
+	add	x1, x1, :lo12:.LC84
 	bl	_dev_info
-.LVL845:
-	b	.L880
-.LVL846:
+.LVL860:
+	b	.L889
+.L793:
+	.loc 1 1407 0
+	ldr	x0, [x24, 88]
+	adrp	x1, .LC85
+	add	x1, x1, :lo12:.LC85
+	bl	_dev_info
+.LVL861:
+	.loc 1 1408 0
+	mov	x0, x28
+	bl	ebc_remove_from_dsp_buf_list
+.LVL862:
+	.loc 1 1409 0
+	mov	x0, x28
+	bl	ebc_buf_release
+.LVL863:
+	.loc 1 1411 0
+	b	.L766
+.LVL864:
 	.p2align 3
-.L911:
-.LBB1834:
-.LBB1822:
+.L917:
+.LBB1827:
+.LBB1815:
+	.loc 1 416 0
+	orr	w3, w3, 61440
+	b	.L810
+	.p2align 3
+.L918:
 	.loc 1 422 0
 	orr	w3, w3, 983040
-	b	.L803
+	b	.L812
 	.p2align 3
-.L912:
+.L919:
 	.loc 1 428 0
 	orr	w3, w3, 15728640
-	b	.L805
+	b	.L814
 	.p2align 3
-.L913:
+.L920:
 	.loc 1 434 0
 	orr	w3, w3, 251658240
-	b	.L807
-.LVL847:
+	b	.L816
+.LVL865:
 	.p2align 3
-.L914:
+.L921:
 	.loc 1 440 0
 	orr	w3, w3, -268435456
-.LVL848:
+.LVL866:
 	.loc 1 445 0
 	and	w1, w1, w25
-.LVL849:
+.LVL867:
 	eor	w1, w1, w3
-.LVL850:
+.LVL868:
 	.loc 1 389 0
 	add	w4, w4, 1
 	and	w1, w1, w18
@@ -9593,300 +9578,281 @@ ebc_thread:
 	.loc 1 446 0
 	str	w1, [x7, x0]
 	.loc 1 389 0
-	ble	.L866
-.LVL851:
+	ble	.L875
+.LVL869:
 	.p2align 2
-.L812:
+.L821:
 	.loc 1 384 0
 	add	w14, w14, 1
 	add	w5, w5, w16
 	cmp	w14, w17
-	ble	.L865
-.L795:
-.LBE1822:
-.LBE1834:
-	.loc 1 1426 0
+	ble	.L874
+.L804:
+.LBE1815:
+.LBE1827:
+	.loc 1 1429 0
 	ldr	w0, [x24, 28]
-	cbnz	w0, .L792
-	.loc 1 1427 0
+	cbnz	w0, .L801
+	.loc 1 1430 0
 	mov	w0, 1
 	str	w0, [x24, 28]
-	.loc 1 1429 0
+	.loc 1 1432 0
 	ldr	w0, [x24, 184]
-	.loc 1 1428 0
-	str	wzr, [x24, 76]
-	.loc 1 1429 0
-	cbz	w0, .L917
-.L813:
 	.loc 1 1431 0
+	str	wzr, [x24, 76]
+	.loc 1 1432 0
+	cbz	w0, .L926
+.L822:
+	.loc 1 1434 0
 	mov	x0, x20
 	bl	ebc_lut_update
-.LVL852:
+.LVL870:
 	cmn	w0, #1
-	beq	.L792
-	.loc 1 1435 0
+	beq	.L801
+	.loc 1 1438 0
 	ldr	w3, [x24, 96]
+	.loc 1 1441 0
+	adrp	x1, .LC86
 	.loc 1 1438 0
-	adrp	x1, .LC83
-	.loc 1 1435 0
 	strb	w3, [x24, 32]
-	.loc 1 1438 0
-	add	x1, x1, :lo12:.LC83
+	.loc 1 1441 0
+	add	x1, x1, :lo12:.LC86
 	ldr	x0, [x24, 88]
-	b	.L881
-.LVL853:
+	b	.L890
+.LVL871:
 	.p2align 3
-.L908:
-.LBB1835:
-.LBB1823:
+.L915:
+.LBB1828:
+.LBB1816:
 	.loc 1 404 0
 	orr	w3, w3, 240
-	b	.L797
+	b	.L806
 	.p2align 3
-.L909:
+.L916:
 	.loc 1 410 0
 	orr	w3, w3, 3840
-	b	.L799
-	.p2align 3
-.L910:
-	.loc 1 416 0
-	orr	w3, w3, 61440
-	b	.L801
-.LVL854:
-.L888:
-.LBE1823:
-.LBE1835:
-	.loc 1 1349 0
-	str	wzr, [x24, 592]
-	.loc 1 1350 0
-	mov	x0, 3
-.LVL855:
-	bl	ebc_notify
-.LVL856:
-	.loc 1 1351 0
-	ldr	x0, [x24, 88]
-	adrp	x1, .LC77
-	add	x1, x1, :lo12:.LC77
-	bl	_dev_info
-.LVL857:
-	b	.L763
-.LVL858:
-.L903:
-	.loc 1 1587 0
+	b	.L808
+.LVL872:
+.L901:
+.LBE1816:
+.LBE1828:
+	.loc 1 1593 0
 	ldr	x0, [x24, 88]
-	.loc 1 1585 0
+	.loc 1 1591 0
 	mov	w25, 1
-.LVL859:
-	.loc 1 1584 0
+.LVL873:
+	.loc 1 1590 0
 	str	wzr, [x24, 188]
-	.loc 1 1587 0
-	adrp	x1, .LC89
-	.loc 1 1585 0
+	.loc 1 1593 0
+	adrp	x1, .LC92
+	.loc 1 1591 0
 	str	w25, [x24, 592]
-	.loc 1 1587 0
-	add	x1, x1, :lo12:.LC89
-	.loc 1 1586 0
+	.loc 1 1593 0
+	add	x1, x1, :lo12:.LC92
+	.loc 1 1592 0
 	str	wzr, [x24, 608]
-	.loc 1 1587 0
+	.loc 1 1593 0
 	bl	_dev_info
-.LVL860:
-	.loc 1 1588 0
+.LVL874:
+	.loc 1 1594 0
 	mov	x0, 2
 	bl	ebc_notify
-.LVL861:
-	.loc 1 1589 0
+.LVL875:
+	.loc 1 1595 0
 	mov	w2, w25
 	mov	w1, w25
 	add	x0, x21, 328
 	bl	__wake_up_sync
-.LVL862:
-	b	.L832
-.L785:
-	.loc 1 1415 0
+.LVL876:
+	b	.L841
+.L794:
+	.loc 1 1418 0
 	ldr	x1, [x0, 16]
 	ldrsw	x2, [x24, 20]
 	ldr	x0, [x24, 128]
 	bl	memcpy
-.LVL863:
-	.loc 1 1416 0
+.LVL877:
+	.loc 1 1419 0
 	ldr	x0, [x24, 200]
 	ldrsw	x2, [x24, 20]
 	ldr	x1, [x0, 16]
 	ldr	x0, [x24, 136]
 	bl	memcpy
-.LVL864:
-	.loc 1 1417 0
+.LVL878:
+	.loc 1 1420 0
 	ldr	x0, [x24, 200]
 	ldrsw	x2, [x24, 20]
 	ldr	x1, [x0, 16]
 	ldr	x0, [x24, 144]
 	bl	memcpy
-.LVL865:
+.LVL879:
 	ldr	x0, [x24, 208]
-	b	.L787
-.LVL866:
-.L900:
-	.loc 1 1534 0
-	mov	w0, 2
-	.loc 1 1535 0
-	mov	w23, 0
-	.loc 1 1534 0
-	str	w0, [x28, 40]
-	b	.L824
-.LVL867:
-.L784:
-	.loc 1 1404 0
+	b	.L796
+.LVL880:
+.L897:
+	.loc 1 1349 0
+	str	wzr, [x24, 592]
+	.loc 1 1350 0
+	mov	x0, 3
+.LVL881:
+	bl	ebc_notify
+.LVL882:
+	.loc 1 1351 0
 	ldr	x0, [x24, 88]
-	adrp	x1, .LC82
-	add	x1, x1, :lo12:.LC82
+	adrp	x1, .LC79
+	add	x1, x1, :lo12:.LC79
 	bl	_dev_info
-.LVL868:
-	.loc 1 1405 0
-	mov	x0, x28
-	b	.L879
-.L814:
-	.loc 1 1455 0
-	ldr	x0, [x24, 128]
-	mov	x3, x24
-	ldr	x2, [x24, 152]
-	ldr	x1, [x28, 16]
-	bl	refresh_new_image_auto
-.LVL869:
-	b	.L815
-.L915:
-.LBB1836:
-.LBB1827:
-.LBB1828:
-	.loc 1 1559 0 discriminator 1
+.LVL883:
+	b	.L771
+.LVL884:
+.L922:
+.LBB1829:
+.LBB1820:
+.LBB1821:
+	.loc 1 1562 0 discriminator 1
 	add	x27, x21, 352
-.LBE1828:
+.LBE1821:
 	mov	w1, 0
 	add	x0, x29, 112
 	bl	init_wait_entry
-.LVL870:
-	b	.L830
+.LVL885:
+	b	.L839
 	.p2align 3
-.L918:
-.LVL871:
-.LBB1829:
-	.loc 1 1559 0 is_stmt 0 discriminator 5
-	cbnz	x0, .L827
-	.loc 1 1559 0 discriminator 7
+.L927:
+.LVL886:
+.LBB1822:
+	.loc 1 1562 0 is_stmt 0 discriminator 5
+	cbnz	x0, .L836
+	.loc 1 1562 0 discriminator 7
 	bl	schedule
-.LVL872:
-.L830:
-	.loc 1 1559 0 discriminator 9
+.LVL887:
+.L839:
+	.loc 1 1562 0 discriminator 9
 	add	x1, x29, 112
 	mov	w2, 1
 	mov	x0, x27
 	bl	prepare_to_wait_event
-.LVL873:
+.LVL888:
 	ldr	w1, [x24, 76]
-	cbz	w1, .L918
-.LBE1829:
-	.loc 1 1559 0 discriminator 4
+	cbz	w1, .L927
+.LBE1822:
+	.loc 1 1562 0 discriminator 4
 	mov	x0, x27
 	add	x1, x29, 112
 	bl	finish_wait
-.LVL874:
-	b	.L827
-.LVL875:
-.L917:
-.LBE1827:
-.LBE1836:
-	.loc 1 1430 0 is_stmt 1
+.LVL889:
+	b	.L836
+.LVL890:
+.L926:
+.LBE1820:
+.LBE1829:
+	.loc 1 1433 0 is_stmt 1
 	mov	x0, x20
 	bl	ebc_power_set.constprop.12
-.LVL876:
-	b	.L813
-.LVL877:
-.L916:
-.LBB1837:
-.LBB1831:
-.LBB1832:
-	.loc 1 1393 0 discriminator 1
+.LVL891:
+	b	.L822
+.LVL892:
+.L925:
+.LBB1830:
+.LBB1824:
+.LBB1825:
+	.loc 1 1396 0 discriminator 1
 	add	x26, x21, 352
-.LVL878:
-.LBE1832:
+.LVL893:
+.LBE1825:
 	mov	w1, 0
 	add	x0, x29, 112
 	bl	init_wait_entry
-.LVL879:
-	b	.L776
+.LVL894:
+	b	.L785
 	.p2align 3
-.L919:
-.LVL880:
-.LBB1833:
-	.loc 1 1393 0 is_stmt 0 discriminator 5
-	cbnz	x0, .L773
-	.loc 1 1393 0 discriminator 7
+.L928:
+.LVL895:
+.LBB1826:
+	.loc 1 1396 0 is_stmt 0 discriminator 5
+	cbnz	x0, .L782
+	.loc 1 1396 0 discriminator 7
 	bl	schedule
-.LVL881:
-.L776:
-	.loc 1 1393 0 discriminator 9
+.LVL896:
+.L785:
+	.loc 1 1396 0 discriminator 9
 	add	x1, x29, 112
 	mov	w2, 1
 	mov	x0, x26
 	bl	prepare_to_wait_event
-.LVL882:
+.LVL897:
 	ldr	w1, [x24, 76]
-	cbz	w1, .L919
-.LBE1833:
-	.loc 1 1393 0 discriminator 4
+	cbz	w1, .L928
+.LBE1826:
+	.loc 1 1396 0 discriminator 4
 	mov	x0, x26
 	add	x1, x29, 112
 	bl	finish_wait
-.LVL883:
-	b	.L773
-.LVL884:
-.L907:
-.LBE1831:
-.LBE1837:
-	.loc 1 1419 0 is_stmt 1
+.LVL898:
+	b	.L782
+.LVL899:
+.L914:
+.LBE1824:
+.LBE1830:
+	.loc 1 1422 0 is_stmt 1
 	ldrsw	x2, [x24, 20]
 	ldp	x1, x0, [x24, 136]
 	bl	memcpy
-.LVL885:
+.LVL900:
 	ldr	x0, [x24, 208]
-	b	.L787
-.LVL886:
-.L889:
-.LBB1838:
-.LBB1839:
+	b	.L796
+.L823:
+	.loc 1 1458 0
+	ldr	x0, [x24, 128]
+	mov	x3, x24
+	ldr	x2, [x24, 152]
+	ldr	x1, [x28, 16]
+	bl	refresh_new_image_auto
+.LVL901:
+	b	.L824
+.LVL902:
+.L903:
+.LBB1831:
+.LBB1832:
 	mov	w1, 0
 	mov	x0, x20
 	bl	ebc_power_set.part.8
-.LVL887:
-	b	.L760
-.LVL888:
-.L897:
-.LBE1839:
-.LBE1838:
-	.loc 1 1466 0
-	ldr	x0, [x24, 88]
-	adrp	x1, .LC84
-	add	x1, x1, :lo12:.LC84
-	bl	_dev_err
-.LVL889:
+.LVL903:
+	b	.L768
+.LVL904:
+.L923:
+.LBE1832:
+.LBE1831:
 	.loc 1 1467 0
-	b	.L792
-.L896:
-	.loc 1 1464 0
 	mov	x0, x20
 	bl	ebc_power_set.constprop.12
-.LVL890:
-	b	.L816
-.L906:
-	.loc 1 1377 0
+.LVL905:
+	.loc 1 1468 0
+	mov	x0, x20
+	bl	ebc_lut_update
+.LVL906:
+	cmn	w0, #1
+	bne	.L826
+.L924:
+	.loc 1 1469 0
+	ldr	x0, [x24, 88]
+	adrp	x1, .LC87
+	add	x1, x1, :lo12:.LC87
+	bl	_dev_err
+.LVL907:
+	.loc 1 1470 0
+	b	.L801
+.L913:
+	.loc 1 1380 0
 	mov	x0, x20
 	bl	ebc_power_set.constprop.12
-.LVL891:
-	b	.L768
-.LVL892:
-.L890:
-	.loc 1 1622 0
+.LVL908:
+	b	.L777
+.LVL909:
+.L904:
+	.loc 1 1628 0
 	bl	__stack_chk_fail
-.LVL893:
+.LVL910:
 	.cfi_endproc
 .LFE2826:
 	.size	ebc_thread, .-ebc_thread
@@ -9899,7 +9865,7 @@ ebc_driver:
 	.xword	ebc_probe
 	.xword	ebc_remove
 	.zero	24
-	.xword	.LC91
+	.xword	.LC94
 	.zero	32
 	.xword	ebc_match
 	.zero	64
@@ -9911,7 +9877,7 @@ ebc_driver:
 ebc_misc:
 	.word	243
 	.zero	4
-	.xword	.LC44
+	.xword	.LC46
 	.xword	ebc_ops
 	.zero	56
 	.type	ebc_thread_wq, %object
@@ -9945,7 +9911,7 @@ ebc_auto_thread_sem:
 	.type	dev_attr_waveform_version, %object
 	.size	dev_attr_waveform_version, 32
 dev_attr_waveform_version:
-	.xword	.LC98
+	.xword	.LC101
 	.hword	292
 	.zero	6
 	.xword	waveform_version_read
@@ -9953,7 +9919,7 @@ dev_attr_waveform_version:
 	.type	dev_attr_pmic_name, %object
 	.size	dev_attr_pmic_name, 32
 dev_attr_pmic_name:
-	.xword	.LC97
+	.xword	.LC100
 	.hword	292
 	.zero	6
 	.xword	pmic_name_read
@@ -9961,7 +9927,7 @@ dev_attr_pmic_name:
 	.type	dev_attr_pmic_temp, %object
 	.size	dev_attr_pmic_temp, 32
 dev_attr_pmic_temp:
-	.xword	.LC96
+	.xword	.LC99
 	.hword	292
 	.zero	6
 	.xword	pmic_temp_read
@@ -9969,7 +9935,7 @@ dev_attr_pmic_temp:
 	.type	dev_attr_pmic_vcom, %object
 	.size	dev_attr_pmic_vcom, 32
 dev_attr_pmic_vcom:
-	.xword	.LC95
+	.xword	.LC98
 	.hword	420
 	.zero	6
 	.xword	pmic_vcom_read
@@ -9977,7 +9943,7 @@ dev_attr_pmic_vcom:
 	.type	dev_attr_ebc_version, %object
 	.size	dev_attr_ebc_version, 32
 dev_attr_ebc_version:
-	.xword	.LC94
+	.xword	.LC97
 	.hword	292
 	.zero	6
 	.xword	ebc_version_read
@@ -9985,7 +9951,7 @@ dev_attr_ebc_version:
 	.type	dev_attr_ebc_state, %object
 	.size	dev_attr_ebc_state, 32
 dev_attr_ebc_state:
-	.xword	.LC93
+	.xword	.LC96
 	.hword	292
 	.zero	6
 	.xword	ebc_state_read
@@ -9993,7 +9959,7 @@ dev_attr_ebc_state:
 	.type	dev_attr_ebc_buf_state, %object
 	.size	dev_attr_ebc_buf_state, 32
 dev_attr_ebc_buf_state:
-	.xword	.LC92
+	.xword	.LC95
 	.hword	292
 	.zero	6
 	.xword	ebc_buf_state_read
@@ -10032,9 +9998,9 @@ __func__.34976:
 	.size	__func__.34774, 16
 __func__.34774:
 	.string	"ebc_frame_start"
-	.type	__func__.35267, %object
-	.size	__func__.35267, 12
-__func__.35267:
+	.type	__func__.35274, %object
+	.size	__func__.35274, 12
+__func__.35274:
 	.string	"ebc_suspend"
 	.zero	4
 	.type	__func__.35208, %object
@@ -10070,9 +10036,9 @@ ebc_ops:
 	.zero	176
 	.section	.discard.addressable,"aw",@progbits
 	.align	3
-	.type	__addressable_ebc_init2503, %object
-	.size	__addressable_ebc_init2503, 8
-__addressable_ebc_init2503:
+	.type	__addressable_ebc_init2529, %object
+	.size	__addressable_ebc_init2529, 8
+__addressable_ebc_init2529:
 	.xword	ebc_init
 	.section	.exitcall.exit,"aw",@progbits
 	.align	3
@@ -10130,7 +10096,7 @@ __exitcall_ebc_exit:
 	.string	"%d\n"
 	.zero	4
 .LC16:
-	.string	"2.08"
+	.string	"2.09"
 	.zero	3
 .LC17:
 	.string	"%s\n"
